/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.efectivo;

import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteEfectivoDAO extends EfectivoDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteEfectivoDAO.class.getName());

    public SQLiteEfectivoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<Efectivo> findAll() {
        List<Efectivo> efectivoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from efectivos";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            efectivoList = this.efectivosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }

        return efectivoList;
    }

    @Override
    public Efectivo findById(int id) {
        Efectivo efectivo = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from efectivos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            efectivo = this.efectivosFromResultSet(rs).get(0);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }

        return efectivo;
    }

    @Override
    public Efectivo findByCaja(Caja caja) {
        Efectivo efectivo = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from efectivos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            List<Efectivo> efectivoList = this.efectivosFromResultSet(rs);
            if (efectivoList.size() > 0) {
                efectivo = efectivoList.get(0);
            }

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }

        return efectivo;
    }

    @Override
    public boolean insertEfectivo(Efectivo efectivo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into efectivos (veinte_mil, diez_mil, cinco_mil, dos_mil, mil, quinientos, cien, cincuenta, diez, caja_id) values (?,?,?,?,?,?,?,?,?,?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, efectivo.getVeinteMil());
            ps.setInt(2, efectivo.getDiezMil());
            ps.setInt(3, efectivo.getCincoMil());
            ps.setInt(4, efectivo.getDosMil());
            ps.setInt(5, efectivo.getMil());
            ps.setInt(6, efectivo.getQuinientos());
            ps.setInt(7, efectivo.getCien());
            ps.setInt(8, efectivo.getCincuenta());
            ps.setInt(9, efectivo.getDiez());
            ps.setInt(10, efectivo.getCaja().getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3},{4},{5},{6},{7},{8},{9},{10}] | updates: {11}", new Object[]{query, efectivo.getVeinteMil(), efectivo.getDiezMil(), efectivo.getCincoMil(), efectivo.getDosMil(), efectivo.getMil(), efectivo.getQuinientos(), efectivo.getCien(), efectivo.getCincuenta(), efectivo.getDiez(), efectivo.getCaja().getId(), updates});

            ps.close();


            query = "select last_insert_rowid()";
            ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            rs.next();
            efectivo.setId(rs.getInt(1));

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean insertDefaultEfectivo(Efectivo efectivo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into efectivos (veinte_mil, diez_mil, cinco_mil, dos_mil, mil, quinientos, cien, cincuenta, diez, caja_id) values (0,0,0,0,0,0,0,0,0,?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, efectivo.getCaja().getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, efectivo.getCaja().getId(), updates});

            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            efectivo.setId(rs.getInt(1));

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateEfectivo(Efectivo efectivo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "update efectivos set veinte_mil = ?, diez_mil = ?, cinco_mil = ?, dos_mil = ?, mil = ?, quinientos = ?, cien = ?, cincuenta = ?, diez = ?, caja_id = ? where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, efectivo.getVeinteMil());
            ps.setInt(2, efectivo.getDiezMil());
            ps.setInt(3, efectivo.getCincoMil());
            ps.setInt(4, efectivo.getDosMil());
            ps.setInt(5, efectivo.getMil());
            ps.setInt(6, efectivo.getQuinientos());
            ps.setInt(7, efectivo.getCien());
            ps.setInt(8, efectivo.getCincuenta());
            ps.setInt(9, efectivo.getDiez());
            ps.setInt(10, efectivo.getCaja().getId());
            ps.setInt(11, efectivo.getId());
            updates = ps.executeUpdate();


            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3},{4},{5},{6},{7},{8},{9},{10},{11}] | updates: {12}", new Object[]{query, efectivo.getVeinteMil(), efectivo.getDiezMil(), efectivo.getCincoMil(), efectivo.getDosMil(), efectivo.getMil(), efectivo.getQuinientos(), efectivo.getCien(), efectivo.getCincuenta(), efectivo.getDiez(), efectivo.getCaja().getId(), efectivo.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteEfectivo(Efectivo efectivo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "delete from efectivos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, efectivo.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, efectivo.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalEfectivo(Caja caja) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select veinte_mil + diez_mil + cinco_mil + dos_mil + mil + quinientos + cien + cincuenta + diez from efectivos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            ResultSet rs = ps.executeQuery();
            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }
}
